package exnihilocreatio.client.renderers;

import exnihilocreatio.entities.ProjectileStone;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.init.Blocks;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.client.registry.IRenderFactory;
import org.lwjgl.opengl.GL11;

import javax.annotation.Nonnull;

public class RenderProjectileStone extends Render<ProjectileStone> {
    public RenderProjectileStone(RenderManager renderManager) {
        super(renderManager);
    }

    private static void bufferCuboid(BufferBuilder buffer, double size, double minU, double minV, double maxU, double maxV, double x1, double y1, double z1, double x2, double y2, double z2) {
        size /= 16.0;

        double xMin = Math.min(x1, x2);
        double xMax = Math.max(x1, x2);

        double yMin = Math.min(y1, y2);
        double yMax = Math.max(y1, y2);

        double zMin = Math.min(z1, z2);
        double zMax = Math.max(z1, z2);

        double xUMin = minU + (maxU - minU) * (xMin + 8.0) / 16.0;
        double xUMax = minU + (maxU - minU) * (xMax + 8.0) / 16.0;

        //double yUMin = minU + (maxU - minU) * (yMin + 8.0) / 16.0;
        //double yUMax = minU + (maxU - minU) * (yMax + 8.0) / 16.0;

        double zUMin = minU + (maxU - minU) * (zMin + 8.0) / 16.0;
        double zUMax = minU + (maxU - minU) * (zMax + 8.0) / 16.0;

        //double xVMin = minV + (maxV - minV) * (xMin + 8.0) / 16.0;
        //double xVMax = minV + (maxV - minV) * (xMax + 8.0) / 16.0;

        double yVMin = minV + (maxV - minV) * (yMin + 8.0) / 16.0;
        double yVMax = minV + (maxV - minV) * (yMax + 8.0) / 16.0;

        double zVMin = minV + (maxV - minV) * (zMin + 8.0) / 16.0;
        double zVMax = minV + (maxV - minV) * (zMax + 8.0) / 16.0;

        xMin *= size;
        xMax *= size;

        yMin *= size;
        yMax *= size;

        zMin *= size;
        zMax *= size;

        buffer.func_181662_b(xMin, yMin, zMin).func_187315_a(zUMin, yVMax).func_181663_c(-1, 0, 0).func_181675_d();
        buffer.func_181662_b(xMin, yMin, zMax).func_187315_a(zUMax, yVMax).func_181663_c(-1, 0, 0).func_181675_d();
        buffer.func_181662_b(xMin, yMax, zMax).func_187315_a(zUMax, yVMin).func_181663_c(-1, 0, 0).func_181675_d();
        buffer.func_181662_b(xMin, yMax, zMin).func_187315_a(zUMin, yVMin).func_181663_c(-1, 0, 0).func_181675_d();

        buffer.func_181662_b(xMax, yMin, zMin).func_187315_a(zUMax, yVMax).func_181663_c(1, 0, 0).func_181675_d();
        buffer.func_181662_b(xMax, yMax, zMin).func_187315_a(zUMax, yVMin).func_181663_c(1, 0, 0).func_181675_d();
        buffer.func_181662_b(xMax, yMax, zMax).func_187315_a(zUMin, yVMin).func_181663_c(1, 0, 0).func_181675_d();
        buffer.func_181662_b(xMax, yMin, zMax).func_187315_a(zUMin, yVMax).func_181663_c(1, 0, 0).func_181675_d();

        buffer.func_181662_b(xMin, yMin, zMin).func_187315_a(xUMin, zVMax).func_181663_c(0, -1, 0).func_181675_d();
        buffer.func_181662_b(xMax, yMin, zMin).func_187315_a(xUMax, zVMax).func_181663_c(0, -1, 0).func_181675_d();
        buffer.func_181662_b(xMax, yMin, zMax).func_187315_a(xUMax, zVMin).func_181663_c(0, -1, 0).func_181675_d();
        buffer.func_181662_b(xMin, yMin, zMax).func_187315_a(xUMin, zVMin).func_181663_c(0, -1, 0).func_181675_d();

        buffer.func_181662_b(xMin, yMax, zMin).func_187315_a(xUMin, zVMin).func_181663_c(0, 1, 0).func_181675_d();
        buffer.func_181662_b(xMin, yMax, zMax).func_187315_a(xUMin, zVMax).func_181663_c(0, 1, 0).func_181675_d();
        buffer.func_181662_b(xMax, yMax, zMax).func_187315_a(xUMax, zVMax).func_181663_c(0, 1, 0).func_181675_d();
        buffer.func_181662_b(xMax, yMax, zMin).func_187315_a(xUMax, zVMin).func_181663_c(0, 1, 0).func_181675_d();

        buffer.func_181662_b(xMin, yMin, zMin).func_187315_a(xUMax, yVMax).func_181663_c(0, 0, -1).func_181675_d();
        buffer.func_181662_b(xMin, yMax, zMin).func_187315_a(xUMax, yVMin).func_181663_c(0, 0, -1).func_181675_d();
        buffer.func_181662_b(xMax, yMax, zMin).func_187315_a(xUMin, yVMin).func_181663_c(0, 0, -1).func_181675_d();
        buffer.func_181662_b(xMax, yMin, zMin).func_187315_a(xUMin, yVMax).func_181663_c(0, 0, -1).func_181675_d();

        buffer.func_181662_b(xMin, yMin, zMax).func_187315_a(xUMin, yVMax).func_181663_c(0, 0, 1).func_181675_d();
        buffer.func_181662_b(xMax, yMin, zMax).func_187315_a(xUMax, yVMax).func_181663_c(0, 0, 1).func_181675_d();
        buffer.func_181662_b(xMax, yMax, zMax).func_187315_a(xUMax, yVMin).func_181663_c(0, 0, 1).func_181675_d();
        buffer.func_181662_b(xMin, yMax, zMax).func_187315_a(xUMin, yVMin).func_181663_c(0, 0, 1).func_181675_d();
    }

    private static TextureAtlasSprite getTexture(IBlockState state) {
        return Minecraft.func_71410_x().func_175602_ab().func_175023_a().func_178122_a(state);
    }

    @Override
    protected ResourceLocation func_110775_a(@Nonnull ProjectileStone stone) {
        return new ResourceLocation("minecraft:blocks/stone");
    }

    @Override
    public void func_76986_a(@Nonnull ProjectileStone entity, double x, double y, double z, float entityYaw, float partialTicks) {
        TextureAtlasSprite texture = getTexture(Blocks.field_150348_b.func_176223_P());

        Tessellator tessellator = Tessellator.func_178181_a();
        BufferBuilder buffer = tessellator.func_178180_c();

        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x, y, z);

        double minU = (double) texture.func_94209_e();
        double maxU = (double) texture.func_94212_f();
        double minV = (double) texture.func_94206_g();
        double maxV = (double) texture.func_94210_h();

        this.func_110776_a(TextureMap.field_110575_b);

        buffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);

        double size = 0.5;

        //bufferCuboid(buffer, 1, minU, minV, maxU, maxV, -8, -8, -8, 8, 8, 8);

        bufferCuboid(buffer, size, minU, minV, maxU, maxV, -4, -2, -2, -2, 2, 2);
        bufferCuboid(buffer, size, minU, minV, maxU, maxV, 4, 2, 2, 2, -2, -2);
        bufferCuboid(buffer, size, minU, minV, maxU, maxV, -2, -4, -2, 2, -2, 2);
        bufferCuboid(buffer, size, minU, minV, maxU, maxV, 2, 4, 2, -2, 2, -2);
        bufferCuboid(buffer, size, minU, minV, maxU, maxV, -2, -2, -4, 2, 2, -2);
        bufferCuboid(buffer, size, minU, minV, maxU, maxV, 2, 2, 4, -2, -2, 2);

        tessellator.func_78381_a();

        GlStateManager.func_179084_k();
        GlStateManager.func_179145_e();
        GlStateManager.func_179121_F();
    }

    public static class Factory implements IRenderFactory<ProjectileStone> {
        @Override
        public Render<ProjectileStone> createRenderFor(RenderManager manager) {
            return new RenderProjectileStone(manager);
        }
    }
}
